image: docker

services:
  - docker:dind

stages:
  - build
  - push
  - deploy

build-dev:
  stage: build
  script:
    - cp /resources/hype2u-web/.env.* ${CI_PROJECT_DIR}/
    - docker build --build-arg env=dev -t registry.digitalocean.com/lobbi/hype2u-dev-web:${CI_COMMIT_SHORT_SHA} .
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "dev"'

push-dev:
  stage: push
  script:
    - docker push registry.digitalocean.com/lobbi/hype2u-dev-web:${CI_COMMIT_SHORT_SHA}
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "dev"'

deploy-dev:
  stage: deploy
  before_script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$DEV_PRIVATE_KEY" | base64 -d)
    - mkdir -p ~/.ssh
  script:
    - ssh $DEV_IP_ADDRESS -oStrictHostKeyChecking=no "docker service update --image registry.digitalocean.com/lobbi/hype2u-dev-web:${CI_COMMIT_SHORT_SHA} web && docker system prune -af"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "dev"'

build-prod:
  stage: build
  script:
    - cp /resources/hype2u-web/.env.* ${CI_PROJECT_DIR}/
    - docker build --build-arg env=production -t registry.digitalocean.com/lobbi/hype2u-web:${CI_COMMIT_SHORT_SHA} .
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "master"'

push-prod:
  stage: push
  script:
    - docker push registry.digitalocean.com/lobbi/hype2u-web:${CI_COMMIT_SHORT_SHA}
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "master"'

deploy-prod:
  stage: deploy
  before_script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$PROD_PRIVATE_KEY" | base64 -d)
    - mkdir -p ~/.ssh
  script:
    - ssh $PROD_IP_ADDRESS -oStrictHostKeyChecking=no "docker service update --image registry.digitalocean.com/lobbi/hype2u-web:${CI_COMMIT_SHORT_SHA} web && docker system prune -af"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "master"'